<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_manuals_article_details.php                        ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/

	function manuals_article_details($block_name) {
		global $t, $db, $table_prefix, $settings, $datetime_show_format;

		$article_id = get_param("article_id");
		$t->set_file("block_body", "block_manuals_article_details.html");
		$t->set_var("MANUALS_PREV_ARTICLE", MANUALS_PREV_ARTICLE);
		$t->set_var("MANUALS_NEXT_ARTICLE", MANUALS_NEXT_ARTICLE);
		$t->set_var("MANUAL_CONTENT_MSG", MANUAL_CONTENT_MSG);
		

		$sql = "SELECT * FROM ".$table_prefix."manuals_articles WHERE article_id=".$db->tosql($article_id, INTEGER);
		$sql .= " AND ";
		$sql .= " allowed_view = 1";
		$db->query($sql);
		if ($db->next_record()) {
			$article_title = $db->f("article_title");
			$article_order = $db->f("article_order");
			$section_number = $db->f("section_number");
			$parent_article_id = $db->f("parent_article_id");
			$short_description = $db->f("short_description");
			$article = $db->Record;

			$full_description = $db->f("full_description");
			$alias_article_id = $db->f("alias_article_id");
			
			// if $full_description is empty and alias article specified 
			// read alias article info
			if ($full_description == "" && $alias_article_id > 0) {
				$sql = "SELECT * FROM ".$table_prefix."manuals_articles WHERE article_id=";
				$sql .= $db->tosql($alias_article_id, INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$full_description = $db->f("full_description");
				}
			}

			$t->set_var("article_title", $article_title);
			$t->set_var("section_number", $section_number);
			$t->set_var("short_description", $short_description);
			
			$level = count(explode(".", $section_number));
			$t->set_var("level", $level);
			$content = parse_special_tags($full_description);

			set_prev_article($article);
			set_index($article);
			set_next_article($article);

			if ($content == "") {
				$t->set_var("full_description", MANUAL_ARTICLE_NO_CONTENT_MSG);
			} else {
				$t->set_var("full_description", $content);
			}
		}
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}
	
	/**
	 * Parse special tags
	 *
	 * @param string $text
	 * @return string
	 */
	function parse_special_tags($text) {

		$parsers = array();
		// Description
		$parsers[] = array(
			"regexp" => "/\[article\s+friendly_url\s{0,}=\s{0,}(.[^\]#]+)([0-9a-z_#]{0,})\s{0,}]/",
			"name" => "article"
		);
/*		
		$text = "[article friendly_url=lalal_bla_bla_1#anchore]";
		$s = "/\[article\s+friendly_url\s{0,}=\s{0,}(.[^\]#]+)([0-9a-z_#]{0,})\s{0,}]/";
		$result = preg_match_all($s, $text, $matches);
		var_dump($matches);
//*/
		foreach ($parsers as $parser_info) {
			$regexp = $parser_info["regexp"];
			$name = $parser_info["name"];
			
			$result = preg_match_all($regexp, $text, $matches);

			if ($result) {
				switch ($name) {
					// Tags proceessing
					case "article":

						foreach ($matches[1] as $key => $friendly_url) {
							$section_number = get_section_info($friendly_url);
							if (isset($matches[2]) && isset($matches[2][$key])) {
								$friendly_url .= $matches[2][$key];
							}
							if ($section_number != "") {
								$url = "<a href=\"".$friendly_url."\">see section ".$section_number."</a>";
								$text = str_replace($matches[0][$key], $url, $text);
							} else {
								$link_title = "see details";
								$url = "<a href=\"".$friendly_url."\">".$link_title."</a>";
								$text = str_replace($matches[0][$key], $url, $text);
							}
						}
					break;
				}
			}
		}
		return $text;
	}
	
	function get_section_info($friendly_url) {
		global $db;
		global $table_prefix;
		
		$section_number = "";
		$sql = "SELECT section_number FROM ".$table_prefix."manuals_articles WHERE friendly_url = ".$db->tosql($friendly_url, TEXT);
		$db->query($sql);
		if ($db->next_record()) {
			$section_number = $db->f("section_number");
		}
		return $section_number;
	}
	
	function set_prev_article($article) {
		global $table_prefix, $db, $t;

		// Count prev section
		$section_number = $article["section_number"];
		$decimals = explode(".", $section_number);
		$last_number = $decimals[count($decimals) - 1];
		if ($last_number == 1) {
			unset($decimals[count($decimals) - 1]);
		} else {
			$decimals[count($decimals) - 1]--;
		}
		$prev_section = implode(".", $decimals);

		$sql = "SELECT article_id, friendly_url ";
		$sql .= "FROM ".$table_prefix."manuals_articles ";
		$sql .= "WHERE section_number = ".$db->tosql($prev_section, TEXT);
		$sql .= " AND manual_id = ".$db->tosql($article["manual_id"], INTEGER);
		$db->query($sql);
		
		if ($db->next_record()) {
			$article_id = $db->f("article_id");

			$friendly_url = $db->f("friendly_url");
			if ($friendly_url == "") {
				$src = "manuals_article_details.php?article_id=".$article_id;
			} else {
				$src = $friendly_url;
			}
			
			$t->set_var("friendly_url", $src);
			$t->parse("prev_article", false);
		} else {
			$t->set_var("prev_article", "");
		}
	}
	
	function set_next_article($article) {
		global $table_prefix, $db, $t;
		// Get next possible section numbers
		$section_number = $article["section_number"];
		$decimals = explode(".", $section_number);
		$sections = array();
		$sections[] = $section_number . ".1";
		
		$section = $decimals;
		
		foreach ($decimals as $decimal) {
			
			$section[count($section) - 1]++;
			$sections[] = implode(".", $section);
			unset($section[count($section) - 1]);
		}

		$sql = "SELECT article_id, friendly_url, section_number ";
		$sql .= "FROM ".$table_prefix."manuals_articles ";
		$sql .= "WHERE  manual_id = ".$db->tosql($article["manual_id"], INTEGER);
		if (is_array($sections) && !empty($sections)) {
			foreach ($sections as $section) {
				$query_str[] = " section_number = " . $db->tosql($section, TEXT);
			}
			$sql .= " AND " . "(" . implode(" OR ", $query_str) . ") ";
		}
		$sql .= "AND allowed_view = 1";
		
		$db->query($sql);
		
		if ($db->next_record()) {
			$exist_sections = array();
			do {
				$section_number = $db->f("section_number");
				$exist_sections[$section_number] = array(
					"article_id" => $db->f("article_id"),
					"friendly_url" => $db->f("friendly_url")
				);
			} while($db->next_record());

			$not_found = true;
			$i = 0;
			do {
				$section = $sections[$i];
				if (isset($exist_sections[$section])) {
					$not_found = false;
					$article_id = $exist_sections[$section]["article_id"];
					$friendly_url = $exist_sections[$section]["friendly_url"];
				}
				// No next article
				if ($i == count($sections)) {
					$not_found = false;
				}
				$i++;
			} while ($not_found);

			if ($friendly_url == "") {
				$src = "manuals_article_details.php?article_id=".$article_id;
			} else {
				$src = $friendly_url;
			}

			$t->set_var("friendly_url", $src);
			$t->parse("next_article", false);

		} else {
			$t->set_var("next_article", "");
		}
	}
	
	function set_index($article) {
		global $table_prefix, $db, $t;
		$sql = "SELECT manual_id, friendly_url FROM ".$table_prefix."manuals_list";
		$sql .= " WHERE manual_id = ".$db->tosql($article["manual_id"], INTEGER);
		
		$db->query($sql);
		if ($db->next_record()) {
			$manual_id = $db->f("manual_id");
			$friendly_url = $db->f("friendly_url");
			if ($friendly_url == "") {
				$src = "manuals_articles.php?manual_id=".$manual_id;
			} else {
				$src = $friendly_url;
			}
			$t->set_var("friendly_url", $src);
			$t->parse("index", false);
		}
	}
?>