<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  forum_topic.php                                          ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./messages/".$language_code."/forum_messages.php");
	include_once ("./messages/".$language_code."/reviews_messages.php");
	include_once ("./includes/sorter.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/tree.php");
	include_once ("./includes/record.php");

	// include blocks
	include_once ("./block_custom.php");
	include_once ("./block_banners.php");

	$display_forums = get_setting_value($settings, "display_forums", 0);
	if ($display_forums == 1) {
		// user need to be logged in before viewing forum 
		check_user_session();
	}
	$user_id = get_session("session_user_id");		
	$page_settings = va_page_settings("forum_topic", 0);
	$currency = get_currency();
	$thread_id = get_param("thread_id");

	$page_friendly_url = ""; 
	$page_friendly_params = array("thread_id");

	// retrieve info about current forum 
	$sql  = " SELECT fl.forum_id, fl.forum_name, f.topic, f.friendly_url, ";
	$sql .= " fl.allowed_view, fl.allowed_view_topics, fl.allowed_view_topic, fl.allowed_post_topics, fl.allowed_post_replies ";
	$sql .= " FROM " . $table_prefix . "forum_list fl, " . $table_prefix . "forum f ";
	$sql .= " WHERE f.forum_id=fl.forum_id AND f.thread_id=" . $db->tosql($thread_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$forum_id = $db->f("forum_id");
		$page_friendly_url = $db->f("friendly_url");
		$allowed_view = $db->f("allowed_view");
		$allowed_view_topics = $db->f("allowed_view_topics");
		$allowed_view_topic = $db->f("allowed_view_topic");
		$allowed_post_topics = $db->f("allowed_post_topics");
		$allowed_post_replies = $db->f("allowed_post_replies");
	} else {
		header ("Location: forums.php");
		exit;
	}

	if (!$allowed_view || !$allowed_view_topics || !$allowed_view_topic) {
		header ("Location: forums.php");
		exit;
	} else if ($allowed_view == 2 || $allowed_view_topics == 2 || $allowed_view_topic == 2) {
		// user need to be logged in before viewing forum
		check_user_session();
	}


	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","forum_topic.html");
	$t->set_var("FORUM_TITLE", FORUM_TITLE);
	$t->set_var("ALL_FORUM_TOPICS_MSG", ALL_FORUM_TOPICS_MSG);

	$html_title = ""; $meta_description = ""; $meta_keywords = ""; 
	$t->set_var("current_href", "forum_topic.php");
	include_once ("./header.php");
	if(is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if ($setting_name == "top_products_block") {
				include_once ("./block_top_products.php");
				top_products($setting_value);
			} else if ($setting_name == "products_top_sellers") {
				include_once ("./block_products_top_sellers.php");
				products_top_sellers($setting_value);
			} else if ($setting_name == "search_block") {
				include_once ("./block_search.php");
				search_form($setting_value);
			} else if ($setting_name == "products_recently_viewed") {
				include_once ("./block_products_recently.php");
				products_recently_viewed($setting_value);
			} else if ($setting_name == "login_block") {
				login_form($setting_value);
			} else if ($setting_name == "cart_block") {
				include_once ("./block_cart.php");
				small_cart($setting_value);
			} else if ($setting_name == "subscribe_block") {
				include_once ("./block_subscribe.php");
				subscribe_form($setting_value);
			} else if ($setting_name == "sms_test_block") {
				include_once ("./block_sms_test.php");
				sms_test_form($setting_value);
			} else if ($setting_name == "poll_block") {
				include_once ("./block_poll.php");
				poll_form($setting_value);
			} else if ($setting_name == "language_block") {
				include_once ("./block_language.php");
				language_form($setting_value, $page_settings["language_selection"]);
			} else if ($setting_name == "currency_block") {
				include_once ("./block_currency.php");
				currency_form($setting_value);
			} else if($setting_name == "forum_search_block") {
				include_once ("./block_forum_search.php");
				forum_search($setting_value);
			} else if($setting_name == "forum_breadcrumb") {
				include_once("./block_forum_breadcrumb.php");
				forum_breadcrumb($setting_value);
			} else if($setting_name == "forum_view_topic") {
				include_once("./block_forum_topic.php");
				forum_show_topic($setting_value, $forum_id, $allowed_post_replies, $page_friendly_url, $page_friendly_params);
			} else if (preg_match("/^navigation_block_(\d+)$/", $setting_name, $matches)) {
				include_once("./block_navigation.php");
				navigation_menu($setting_value, $matches[1]);
			} else if (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} else if (preg_match("/^banners_group_/", $setting_name)) {
				banners_group($setting_value, substr($setting_name, 14));
			}
		}
	}
	if(!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if(!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if(!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}

	include_once ("./footer.php");

	$t->set_var("html_title", $html_title);
	$t->set_var("meta_keywords", $meta_keywords);
	$t->set_var("meta_description", get_meta_desc($meta_description));
	$t->pparse("main");
?>