<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ProCart Enterprise 3.8                                       ***
  ***      File:  db_mysql.php                                             ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.ProCart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


class VA_SQL
{  
	var $DBHost         = "";
	var $DBPort         = "";
	var $DBDatabase     = "";
	var $DBUser         = "";
	var $DBPassword     = "";
	var $DBPersistent   = false;

	/* 
	dates formats 
	*/
	var $DatetimeMask   = array("YYYY", "-", "MM", "-", "DD", " ", "HH", ":", "mm", ":", "ss");
	var $DateMask       = array("YYYY", "-", "MM", "-", "DD");
	var $TimeMask       = array("HH", ":", "mm", ":", "ss");
	var $TimestampMask  = array("YYYY", "MM", "DD", "HH", "mm", "ss");

	var $AutoFree       = 0;     
	var $LinkID         = 0;
	var $QueryID        = 0;
	var $PageNumber     = 0;
	var $RecordsPerPage = 0;
	var $Record         = array();
	var $Row            = 0;

	var $Errno       = 0;
	var $Error       = "";
	var $HaltOnError = "yes"; // "yes", "no", "report"

	/* 
	public: constructor 
	*/
	function VA_SQL($query = "") {
		$this->RecordsPerPage = 0;
		$this->query($query);
	}

	function check_lib() {
		return function_exists("mysql_connect");
	}

	function connect() {
		if (!$this->LinkID) {
			$server = ($this->DBPort != "") ? $this->DBHost.":".$this->DBPort : $this->DBHost;
		
			if ($this->DBPersistent) {
				$this->LinkID = @mysql_pconnect($server, $this->DBUser, $this->DBPassword);
			} else {
				$this->LinkID = @mysql_connect($server, $this->DBUser, $this->DBPassword);
			}

			if (!$this->LinkID) {		
				$this->halt("Connect failed: " . $this->describe_error(mysql_errno(), mysql_error()));
				return 0;
			}
		
			if (!mysql_select_db($this->DBDatabase, $this->LinkID)) {
				$this->LinkID = 0;
				$this->halt($this->describe_error(mysql_errno(), mysql_error()));
				return 0;
			}
		}
		
		return $this->LinkID;
	}

	function free() {
		if ($this->QueryID) {
			@mysql_free_result($this->QueryID);
			$this->QueryID = 0;
		}
	}

	function query($query_string) {
		if ($query_string == "") {
			return 0;
		}
	
		if (!$this->connect()) {
			return 0; 
		};
	
		if ($this->QueryID) {
			$this->free();
		}
	
		if ($this->RecordsPerPage && $this->PageNumber) {
			$query_string .= " LIMIT " . (($this->PageNumber - 1) * $this->RecordsPerPage) . ", " . $this->RecordsPerPage;
			$this->RecordsPerPage = 0;
			$this->PageNumber = 0;
		}
	
		$this->QueryID = @mysql_query($query_string, $this->LinkID);
		$this->Row   = 0;
		$this->Errno = mysql_errno();
		$this->Error = mysql_error();
		if (!$this->QueryID) {
			$this->halt("Invalid SQL: " . $query_string);
		}
		
		return $this->QueryID;
	}

	function next_record() {
		if (!$this->QueryID) {
			$this->halt("next_record called with no query pending.");
			return 0;
		}
	
		$this->Record = @mysql_fetch_array($this->QueryID);
		$this->Row   += 1;
		$this->Errno  = mysql_errno();
		$this->Error  = mysql_error();
		
		$stat = is_array($this->Record);
		if (!$stat && $this->AutoFree) {
			$this->free();
		}
		return $stat;
	}

	function seek($pos = 0) {
		$status = @mysql_data_seek($this->QueryID, $pos);
		if ($status) {
			$this->Row = $pos;
		} else {
			$this->halt("seek($pos) failed: result has " . $this->num_rows() . " rows");
		
			@mysql_data_seek($this->QueryID, $this->num_rows());
			$this->Row = $this->num_rows;
			return 0;
		}
		
		return 1;
	}

	function affected_rows() {
		return @mysql_affected_rows($this->LinkID);
	}

	function num_rows() {
		return @mysql_num_rows($this->QueryID);
	}

	function num_fields() {
		return @mysql_num_fields($this->QueryID);
	}

	function f($Name, $field_type = TEXT) {
		if (isset($this->Record[$Name])) {
			$value = $this->Record[$Name];
			switch($field_type) {
				case DATETIME:
					$value = parse_date($this->DatetimeMask, $value);
					break;
				case DATE:
					$value = parse_date($this->DateMask, $value);
					break;
				case TIME:
					$value = parse_date($this->TimeMask, $value);
					break;
			}
			return $value; 
		} else {
			return "";
		}
	}

	function halt($message) {
		global $t, $is_admin_path, $settings;
	
		if (!$this->Error) {
			$this->Error = $message;
		}
	
		if ($this->HaltOnError == "no") {
			return;
		}
	
		$eol = get_eol();
		$request_uri = get_var("REQUEST_URI");
		$http_host = get_var("HTTP_HOST");
		$http_referer = get_var("HTTP_REFERER");
		
		$protocol = (strtoupper(get_var("HTTPS")) == "ON") ? "https://" : "http://";
		$page_url = $protocol . $http_host . $request_uri;
		
		$error_message  = "<b>Page URL:</b> <a href=\"" . $page_url . "\">" . $page_url . "</a><br>" . $eol;
		$error_message .= "<b>Referrer URL:</b> <a href=\"" . $http_referer . "\">" . $http_referer . "</a><br>" . $eol;
		$error_message .= "<b>Database error:</b> " . $message . "<br>" . $eol;
		$error_message .= "<b>MySQL Error:</b> " . $this->Error . "<br>" . $eol;
		
		// to get notification about errors change email address and uncomment mail line below
		$recipients     = "db_error_email@domain_name";
		$subject        = "DB ERROR " . $this->Errno;
		$message        = strip_tags($error_message);
		$email_headers  = "From: db_error_email@domain_name" . $eol;
		$email_headers .= "Content-Type: text/plain";
		// mail($recipients, $subject, $message, $email_headers);
		
		// print warning page 
		if (!isset($t)) {
			if ($is_admin_path) {
				$templates_dir = isset($settings["admin_templates_dir"]) ? $settings["admin_templates_dir"] : "../templates/admin";
			} else {
				$templates_dir = isset($settings["templates_dir"]) ? $settings["templates_dir"] : "./templates/default";
			}
			if (class_exists("VA_Template")) {
				$t = new VA_Template($templates_dir);
			}
		} else {
			$templates_dir = $t->templates_path;
		}
			
		if ($is_admin_path) {
			$template_exists = file_exists($templates_dir . "/" . "admin_error_db.html");
		} else {
			$template_exists = file_exists($templates_dir . "/" . "error_db.html");
		}
			
		if (isset($t) && $template_exists) {
			if ($is_admin_path) {
				$t->set_file("header",   "admin_header.html");
				$t->set_file("footer",   "admin_footer.html");
				$t->set_file("error_db", "admin_error_db.html");
			} else {
				$t->set_file("header",   "header.html");
				$t->set_file("footer",   "footer.html");
				$t->set_file("error_db", "error_db.html");
			}
			$t->set_var("error_message", $error_message);
			$t->set_var("error_number", $this->Errno);
			
			$subject = str_replace("+", "%20", urlencode($subject));
			$message = str_replace("+", "%20", urlencode($message));
			$t->set_var("subject", $subject);
			$t->set_var("body", $message);
			
			
			$t->parse("header", false);
			$t->parse("footer", false);
			$t->pparse("error_db", false);
		} else {
			echo $error_message;
		}
			
		if ($this->HaltOnError != "report") {
			exit;
		}
	}

	function tosql($value, $value_type, $is_delimiters = true, $use_null = true) {
		if (is_array($value) || strlen($value)) {
			switch($value_type) {
				case NUMBER:
				case FLOAT:
					return doubleval(str_replace("," , ".", $value));
					break;
				case TEXT:
					$value = addslashes($value);
					break;
				case DATETIME:
					if (!is_array($value) && is_int($value)) { $value = va_time($value); }
					if (is_array($value)) { $value = va_date($this->DatetimeMask, $value); } 
					else { return "NULL"; }
					break;
				case INTEGER:
					return intval($value);
					break;
				case DATE:
					if(!is_array($value) && is_int($value)) { $value = va_time($value); }
					if(is_array($value)) { $value = va_date($this->DateMask, $value); }
					else { return "NULL"; }
					break;
				case TIME:
					if (!is_array($value) && is_int($value)) { $value = va_time($value); }
					if (is_array($value)) { $value = va_date($this->TimeMask, $value); }
					else { return "NULL"; }
					break;
				case TIMESTAMP:
					if (!is_array($value) && is_int($value)) { $value = va_time($value); }
					if (is_array($value)) { $value = va_date($this->TimestampMask, $value); }
					else { return "NULL"; }
					break;
			}
			if($is_delimiters) {
				$value = "'" . $value . "'";
			}
		} else if ($use_null) {
			$value = "NULL";
		} else {
			if ($value_type == INTEGER || $value_type == FLOAT || $value_type == NUMBER) {
				$value = 0;
			} else if ($is_delimiters) {
				$value = "''";
			}
		} 
		return $value;
	}
	
	function describe_error($error_code, $error_msg) {
		$error_desc = "";
		switch ($error_code) {
			case 2005: // Unknown MySQL Server Host '...' (11001)
				$error_desc = DB_HOST_ERROR;
				break;
			case 2003: // Can't connect to MySQL server on '...' (10061)
				$error_desc = DB_PORT_ERROR;
				break;
			case 1044: // Access denied for user: '...' to database '...'
				$error_desc = DB_USER_PASS_ERROR . " " . $error_msg;
				break;
			case 1045: // Access denied for user: '...' (Using password: YES)
				$error_desc = DB_USER_PASS_ERROR . " " . $error_msg;
				break;
			case 1049: // Unknown database '...'
				$error_desc = str_replace('{db_name}', $this->DBDatabase, DB_NAME_ERROR);
				break;
			default:
				$error_desc = $error_msg;
		}
		return $error_desc;
	}
}

?>